                                                                                                                                                                                                                                                                                 var defaultFirmwareName = 'UC500-Build-1-0-0-47.zip'
var selFirmwareName = '';
var isconnected = 0;
var upgradeAborted = false;
var conDialog;

var BDXPKT_SIZE = 64;
var BDXPKT_HEADER_SIZE = 7;
var BDXPKT_DATA_SIZE_MAX = BDXPKT_SIZE - BDXPKT_HEADER_SIZE;

var totalProgress = 0;
var progressOperations = 6;
var progOperation = 0;

function reportStatus(statstr) {
	var ta = document.getElementById('status');
	ta.value += (statstr + '\n');
    ta.scrollTop = ta.scrollHeight;
}

function clearStatus() {
	var ta = document.getElementById('status');
	ta.value = '';
}

function setProgress(percent) {
	//totalProgress = (100 * (progOperation - 1)) / progressOperations;
	//totalProgress += percent / progressOperations;
	//totalProgress += percent;
	totalProgress = percent;
	if (totalProgress < 0)
		totalProgress = 0;
	else if (totalProgress > 100)
		totalProgress = 100;
	pb = document.getElementById('progbar');
	pb.style.width = 0.98 * totalProgress + '%';

 	pb = document.getElementById('progArea');
	
  str = parseInt(totalProgress) + '%';
  if (str != '0%')
  	pb.textContent = str;
}

function onSelfile() {
	var accepts = [{
		mimeTypes: ['text/*'],
		extensions: ['zip']
	}];
	chrome.fileSystem.chooseEntry({type: 'openFile', suggestedName: defaultFirmwareName, accepts: accepts, },
			function(theEntry) {
		
		if (!theEntry) {
			return;
		}
		// use local storage to retain access to this file
		chrome.storage.local.set({'chosenFile': chrome.fileSystem.retainEntry(theEntry)});
		                                                                                                                                                                                                                                                                                                                                                                                                      
		chrome.fileSystem.getDisplayPath(theEntry, function(displayPath) {
			selFirmwareName = displayPath;
			span = document.getElementById('upgfile');
			span.value = selFirmwareName;
			//butt = document.getElementById('upgrade'); 
			disabled = (isconnected && (selFirmwareName != '')) ? false : true;
			disableButton('upgrade', disabled);
		});
	});
}

// state of block sending
//
var sentBlocks = false;
var packetCount = 0;
var bytesRemain = 0;

var downloadZip;
var downloadContent;
var	downloadPurpose;
var	downloadBytes;
var downloadCount;
var downloadPacket;
var	downloadContentArray;

function abortUpgrade() {
	upgradeAborted = true;
	reportStatus('Aborted upgrade');
	disableButton('abort', true);
	disableButton('upgrade', false);
  disableButton('selfile', false);
}

function completeBlockTransfer(laststat, rxdata) {
	if (laststat == false) {
		reportStatus('End Upgrade failed');
		abortUpgrade();
		return;
	}
	else {
		sentBlocks = true;
	
		// send the flash command, and check its reply
		//
		//setProgress(100);
		upgradeNextFile(downloadZip, downloadContent);
	}
}

function countDown(timeLeft){
 var intervalProc = setInterval(function(){
  timeLeft--;
  if(timeLeft <= 0){
   clearInterval(intervalProc);
  }
 })

}

function waitForTimeout(counter, wait) {
	// 25 second wait at 100ms per = 250 counts 
	if (counter++ > wait) {
		//reportStatus('Flashing complete!');
		return;
	}
	setTimeout(function() {
		setProgress(counter / 2);
		waitForTimeout(counter, wait);
	}, 110);  
}


var lastprog = 0;

function sendNextBlock(laststat, rxdata) {
	var prog = 0;
	var packetBuffer;
	var packetBytes;
	var checksum, chunk, i;

	if (upgradeAborted) {
		return;
	}
	// check download response for error
	//
	if (rxdata != '') {
		reportStatus('Packet TX failed: ' + rxdata);
		abortUpgrade();
		return;
	}
	if (laststat == false) {
		reportStatus('Packet TX failed');
		abortUpgrade();
		return;
	}
	if (bytesRemain > 0) {
		const MAX_BLK_UPG_PACKETS = (8 * 1024); /* usb bulk writes max */
		var maxpackets;
		var packetsleft;

		packetsleft = packetCount - downloadPacket;
		if (packetsleft > MAX_BLK_UPG_PACKETS)
			packetsleft = MAX_BLK_UPG_PACKETS;

		packetBuffer = new ArrayBuffer(64 * packetsleft);
		packetBytes = new Uint8Array(packetBuffer);

		for (n = 0; n < packetsleft; n++) {
			chunk = (bytesRemain > BDXPKT_DATA_SIZE_MAX) ?
				BDXPKT_DATA_SIZE_MAX : bytesRemain;
			k = n * 64;
		    packetBytes[k + 0] = TARGET_UPGRADE;
		    packetBytes[k + 1] = downloadPacket & 0xff;
		    packetBytes[k + 2] = (downloadPacket >> 8) & 0xff;
		    packetBytes[k + 3] = (downloadPacket >> 16) & 0xff;
		    packetBytes[k + 4] = (downloadPacket >> 24) & 0xff;
		    packetBytes[k + 5] = chunk;
	
			for (i = 0; i < chunk; i++)
				packetBytes[i + k + 6] = downloadBytes[downloadCount++];
			while (i < BDXPKT_DATA_SIZE_MAX)
				packetBytes[i++ + k + 6] = 0;
 
			packetBytes[k + 63] = DataPacket_ComputeChecksum(packetBytes.slice(k, k + 63), 63);
			downloadPacket++;
			bytesRemain -= chunk;
		}
        
		// update progress (90 leaves 10% for flash burn time) but only
		// if progress changes by whole integers
		//
		//prog = downloadPacket * 90 / packetCount;
		prog = downloadPacket * 90 / packetCount;
		if ((prog ^ lastprog)) {
			lastprog = prog;
			console.log('pkt ' + downloadPacket + ' of ' + packetCount);
			setProgress(prog);
		}

		SendBulkPacketData(0, packetBuffer, null, function(stat, rxpacket) {
			// start a non-blocking rx to any responses to sends here
			RecvBulkPacketResponse(-1, null, function(status, msg) {  
				if (msg != '') {
					console.log(msg);
					reportStatus(msg);
				}
				if (! status) {
					abortUpgrade();
					return;
				}
				sendNextBlock(stat, rxpacket);
			});
		});		
	}
	else {		
		console.log('complete block xfer');
		reportStatus('Flashing data...');

		msg = 'Ending Upgrade';
		DataPacket_RunCommand(TARGET_UPGRADE, msg, msg.length, msg, completeBlockTransfer);
		waitForTimeout(0, 250);
	}
}

function sendFileBlocks(laststat, rxdata) {	
	if (laststat == false) {
		reportStatus('Download command failed');
		abortUpgrade();
		return;
	}
	sentBlocks = false;
	lastprog = 0;

	// kick-off the block xfer by sending first block
	//
	console.log('Starting blocks');
	//reportStatus('Upgrading. Do not disconnect or remove power until complete');
	sendNextBlock(true, '');
}

function upgradeFile(zipFile, zipFileContent, filepurpose) {	
	// set global state for this file upgrade operation
	downloadZip = zipFile;
	downloadContent = zipFileContent;
	downloadPurpose = filepurpose;
	downloadBytes = zipFileContent;
	downloadCount = 0;

	progOperation++;
	
	if (downloadBytes.length > 0) {
		var msg;
		var byteCount = downloadBytes.length;

		packetCount = Math.round((byteCount + BDXPKT_DATA_SIZE_MAX - 1) / BDXPKT_DATA_SIZE_MAX);
		bytesRemain = byteCount;
		downloadPacket = 0;
		downloadCount  = 0;
		
		clearStatus();
		reportStatus('Upgrade ' + filepurpose + ' with ' + downloadBytes.length + ' bytes');
		sentBlocks = false;

		reportStatus('Downloading file...');

		msg = 'Starting Upgrade ' + bytesRemain + ' ' + packetCount;

		if (0) {
			DataPacket_RunCommand(TARGET_UPGRADE, msg, msg.length, null, sendFileBlocks);
		}
		else {		
			msgArry = new ArrayBuffer(64);
			msgBuf  = new Uint8Array(msgArry);
			for (i = 0; i < msg.length; i++)
				msgBuf[i] = msg.charCodeAt(i);
			while (i < 64)
				msgBuf[i++] = 0;
			DataPacket_RunRawCommand(msgArry, null, function() {
				// seems to need a little delay for this to work right
				// between starting msg and it reading data
				setTimeout(function() {
					sendFileBlocks(true, '');
				}, 500);
			});
		}
	}
	else
		reportStatus('Skipping empty file ' + filename);
}

function bootLoaderDone(laststat) {
	if (laststat == false) {
		reportStatus('Bootloader Upgrade Failed');
		abortUpgrade();
		return;
	}
	upgradeNextFile(downloadZip, downloadContent);
}

function startBootLoaderUpgrade(laststat, rxdata) {
	if (laststat == false) {
		reportStatus('bootmode command failed');
		abortUpgrade();
		return;
	}
	if (upgradeAborted) {
		return;
	}
	// wait a second for the re-enum we did to take place
	//
	reportStatus('Waiting for bootloader ready');
	setTimeout(function() {
			if (upgradeAborted)
				return;
			CyBtldr_Upgrade(downloadContentArray, reportStatus, setProgress, bootLoaderDone);
		},
		300);
}

function upgradeBootLoader(zipFile, filename, filepurpose, filecontents) {
	// set global state for this file upgrade operation
	downloadZip = zipFile;
	downloadPurpose = filepurpose;
	downloadContentArray = filecontents;
	downloadBytes = new Uint8Array(filecontents);
	
	progOperation++;

	if (downloadBytes.length > 0) {
		reportStatus('Upgrade ' + filepurpose + ' with ' + filename + ' of ' + downloadBytes.length + ' bytes');
		// put device into bootloader mode
//		reportStatus('Set bootloader mode');
//		runCommand('cyboot', 'ruby', reportStatus, false, startBootLoaderUpgrade);
    disableButton('upgrade', true);
    disableButton('selfile', true);
    disableButton('abort', false);

		startBootLoaderUpgrade(true, '');
	}
	else
		reportStatus('Skipping empty file ' + filename);
}

function getCapTouchReply(laststat, rxdata) {
	if (laststat == false) {
		reportStatus('Button reprogram command failed');
		abortUpgrade();
		return;
	}
	reportStatus('Button reprogram done');
	setProgress(100);
	// rxdata can be bogus us reenumerated
	setTimeout(function() {
			upgradeNextFile(downloadZip, downloadContent);
		}, 0);
}

function upgradeCapTouch(zipFile, zipFileContent) {
	downloadZip = zipFile;
	downloadContent = zipFileContent

	progOperation++;

	//reportStatus('Reprogram device buttons');
	setProgress(40);
	
	getCapTouchReply(true, '');
//	runCommand('mediac "dsp programcap"', 'login', reportStatus, true, getCapTouchReply);
}

function didSystemReboot(laststat, rxdata) {
	if (laststat == false) {
		abortUpgrade();
		return;
	}
	upgradeNextFile(downloadZip, downloadContent);
}

function waitForReboot(counter) {
	// 20 second wait at 100ms per = 200 counts
	if (counter++ > 200) {
		//reportStatus('Rebooted');
		upgradeNextFile(downloadZip, downloadContent);
		return;
	}
	setTimeout(function() {
		setProgress(counter / 2);
		waitForReboot(counter);
	}, 110);
}

function waitForCyboot(devtype) {
	switch (devtype.type) {
	case USBDEV_NONE:
	default:
		console.log('not connected');
		reportStatus('Device did not restart');
		abortUpgrade();
		break;
	case USBDEV_REVO1:
	case USBDEV_REVO2:
		console.log('did not reboot');
		reportStatus('Device did not reset properly');
		abortUpgrade();
		break;
	case USBDEV_CYP:
		// todo - reboot?
		console.log('found cyboot');
		didSystemReboot(true, '');
		break;
	}
}

function rebootSystem(zipFile, zipFileContent) {
	downloadZip = zipFile;
	downloadContent = zipFileContent
	progOperation++;
	setProgress(0);
//	runCommand('reboot', 'ruby', reportStatus, true, waitSystemReboot);
	// check that device is in cyboot mode and if not, fail
	//
	setTimeout(function() {
			checkDevice(waitForCyboot);
		}, 4000);
}

function zipReadErrorHandler() {
	reportStatus('Bad firmware file');
	abortUpgrade();
}

var didBootLoader = false;

function versionString(laststat, content) {
  content = content.slice(0, 37).trim();
	reportStatus(content);
}

function upgradeNextFile(zipFile, zipFileContent) {
	var file;

	currentOperation++;
	switch (currentOperation) {
	case 1:
		didBootLoader = false;
		needsReboot = false;
 
    disableButton('upgrade', true);
    disableButton('selfile', true);
 
		if (zipFileContent.length > 0) {
			needsReboot = true;
			upgradeFile(zipFile, zipFileContent, 'System Image');
		}
		else
			upgradeNextFile(zipFile, zipFileContent);			
		break;
	case 2:
	case 3:
		upgradeNextFile(zipFile, zipFileContent);
		break;
	case 4:
		// force a reboot of omap if any system files changed
		// (note, that this is done automatically if upgraded, so 
		// this just double checks the device id)
		//
		if (needsReboot) {
			reportStatus('Restarting system');
			rebootSystem(zipFile, zipFileContent);
		} else {
			reportStatus('No system changes, skip restart');
			progOperation++;
			upgradeNextFile(zipFile, zipFileContent);
		}
		break;
	case 5:
		file = zipFile.file(new RegExp(CYPRESS_FILE + '*'));
		if (file.length > 0) {
			upgContent = zipFile.file(CYPRESS_FILE).asArrayBuffer();
			if (upgContent) {
				upgradeBootLoader(zipFile, CYPRESS_FILE, "Boot Loader", upgContent);
				didBootLoader = true;
			}
			else
				upgradeNextFile(zipFile, zipFileContent);
		} else
			upgradeNextFile(zipFile, zipFileContent);
		break;
	case 6:
		reportStatus('Resetting system...');
		disableButton('abort', true);
		
		if (! didBootLoader) {
			// didn't reset so don't wait
			progOperation++;
			upgradeNextFile(zipFile, zipFileContent);
		} else {
			// system will self-boot, let it, but close down
			// since re-enum will break open connection
			progOperation++;
			downloadZip = zipFile;
			downloadContent = zipFileContent;

			waitForReboot(0);
		}
		break;
	case 7:
		// this one is always done, and last, after reboot
		//
		upgradeCapTouch(zipFile, zipFileContent);
		break;
	case 8:
		// done
		setTimeout(function() {
  		DataPacket_RunCommand(TARGET_VERSIONRETRIEVAL, 'Version Retrieval', 17, null, versionString);
	  }, 2000);

		currentOperation = 0;
		reportStatus('Upgrade complete');

    disableButton('upgrade', false);
    disableButton('selfile', false);
    disableButton('abort', true);

		break;
	}
	// getting here means all done with file upgrades
}

function isValidZipFile(files) {
  if (files.length != 4) return false;
  
  var goodFiles = ['cypressUSB.cyacd', 'sboot.sebn', 'kernel.sebn', 'rootfs.sebn'];
  var found = false;
  
  for (var i=0; i<files.length; i++) {
    for (var k=0; k<files.length; k++) {
      if (files[i].name == goodFiles[k]) {
        found = true;
        break;
      }
    }
    if (!found) return false;
    found = false;
  }
  
  return true;
}

function openZipFile(fileEntry) {
	var zipFile = new JSZip();
	var reader = new FileReader();
	
	// read file into Uint8array
	//
	fileEntry.file(function(file) {
		reader.onerror = zipReadErrorHandler;
	
		reader.onloadend = function(e) {
			var zipbytes = new Uint8Array(e.target.result);
			var zipfiles = {};
			
			//reportStatus('Unzipping firmware file');
      try {
  			zipFile.load(zipbytes);
      }
      catch (e) {
			  zipReadErrorHandler();
			  return;
			}

			// enumerate files in zip to get count
			//
			files = zipFile.file(new RegExp('.*'));
			
			progressOperations = 2; // for the non-file upgrade part and reboot part
			
			if (!isValidZipFile(files)) {
			  clearStatus();
			  reportStatus('Invalid zip file!');
			  onAbort();
			  return;
			}
			// if loading each file individually
			if (1) {
				for (var n = 0; n < files.length; n++) {
					// todo - check each name?  for
					// now just assume any file in the zip is valid
					//
					console.log("file name: " + files[n].name);
					//progressOperations++;
				}
			}
			//reportStatus('Found ' + files.length + ' firmware modules');

			// TODO - contruct a new zip file without the cyacd in it and send that
			//
			progOperation = 0;
			upgradeNextFile(zipFile, zipbytes);
		};
		//reportStatus('Invalid zip file!');
		reader.readAsArrayBuffer(file);
	});
}

function onUpgrade() {
	checkDevice(devUpdate);
}
	
function devUpdate(devtype) {	
		if (devtype.type !== 0) {
			clearStatus();
			//reportStatus('Upgrade starting');
			totalProgress = 0;
			// for testing, jump right to bootloader mode
			currentOperation = (devtype.type == USBDEV_CYP) ? 4 : 0;
			setProgress(0);
			chrome.storage.local.get('chosenFile', function(items) {
				if (items.chosenFile) {
					upgradeAborted = false;
					// enable abort button now
					disableButton('abort', false);
					// if an entry was retained earlier, see if it can be restored
					chrome.fileSystem.isRestorable(items.chosenFile, function(bIsRestorable) {
						// the entry is still there, load the content
						chrome.fileSystem.restoreEntry(items.chosenFile, function(chosenEntry) {
							if (chosenEntry) {
								/*
								chrome.fileSystem.getDisplayPath(chosenEntry, function(displayPath) {
									console.log('chose file + ' + displayPath);
								});
								*/
								openZipFile(chosenEntry);
							}
						});
		   	 		});
				} else {
					reportStatus('Missing firmware file');
					upgradeAborted = true;
				}
			});
		}
		else {
			conDialog.showModal();
		}
}

function onAbort() {
	abortUpgrade();
}

function showDeviceState(connected) {
    disableState = (connected.state == 'Disconnected');
    
		span = document.getElementById('connstat');
		txt = document.createTextNode(connected.state);
		span.innerText = txt.textContent;
		
		disableButton('selfile', disableState);
		disableButton('upgrade', (disableState || (selFirmwareName === '')));
}

function updateConnStatus() {
	checkDevice(showDeviceState);
}

function onPlugDevice(device) {
	console.log('Plug device ' + device.vendorId + ':' + device.productId);
	updateConnStatus();
}

function onPullDevice(device) {
	console.log('Pulled device ' + device.vendorId + ':' + device.productId);
	updateConnStatus();
}

document.addEventListener('DOMContentLoaded', function () {
	//console.log('loaded upgrade page');
	conDialog = document.getElementById('connectMeNowDialog');
	document.querySelector('#connectMeNowClose').onclick = function() {
		conDialog.close();
	};
	setProgress(0);
	
	document.getElementById('selfile').addEventListener('click', onSelfile);
	document.getElementById('upgrade').addEventListener('click', onUpgrade);
	document.getElementById('abort').addEventListener('click', onAbort);

	chrome.usb.onDeviceAdded.addListener(onPlugDevice)
	chrome.usb.onDeviceRemoved.addListener(onPullDevice)

  disableButton('upgrade', true);
  disableButton('abort', true);

	var ta = document.getElementById('status');
	ta.value = '';
	reportStatus('Select File');

	isconnected = -1;
	updateConnStatus();

	/* not needed, listing for plug events
	setInterval(updateConnStatus, 1000);
	*/
});

